﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Spread_AutoFill
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.fpSpread1.ActiveSheet.RowCount = 5;
            this.fpSpread1.ActiveSheet.ColumnCount = 5;
        }

        private void 自适应ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int spreadW = this.fpSpread1.Width;
            int spreadH = this.fpSpread1.Height;

            //垂直滚动条宽度
            int vScrollBar = SystemInformation.VerticalScrollBarWidth;
            //水平滚动条高度
            int hScrollBar = SystemInformation.HorizontalScrollBarHeight;

            //列头高度
            float columnHeaderH = 0;
            for (int i = 0; i < this.fpSpread1.ActiveSheet.ColumnHeader.RowCount; i++)
            {
                columnHeaderH += this.fpSpread1.ActiveSheet.ColumnHeader.Rows[i].Height+1;
            }

            //行头宽度
            float rowHeaderW = 0;
            for (int i = 0; i < this.fpSpread1.ActiveSheet.RowHeader.ColumnCount; i++)
            {
                rowHeaderW += this.fpSpread1.ActiveSheet.RowHeader.Columns[i].Width+1;
            }

            //剩余宽度和高度
            int leftWidth = spreadW - vScrollBar - Convert.ToInt32(rowHeaderW);
            int leftHeight = spreadH - hScrollBar - Convert.ToInt32(columnHeaderH);

            //计算并设置平均列宽
            int averageColWidth = leftWidth / this.fpSpread1.ActiveSheet.ColumnCount;
            for (int i = 0; i < this.fpSpread1.ActiveSheet.ColumnCount; i++)
            {
                this.fpSpread1.ActiveSheet.Columns[i].Width = averageColWidth;
            }

            //计算并设置平均行高
            int averageRowHeight = leftHeight/ this.fpSpread1.ActiveSheet.RowCount;
            for (int i = 0; i < this.fpSpread1.ActiveSheet.RowCount; i++)
            {
                this.fpSpread1.ActiveSheet.Rows[i].Height = averageRowHeight;
            }
        }
    }
}
